#include "../ClassDecl.h"
#include "../WithDef.h"
#include "../code-files/CfLayout.h"
#include "../code.h"
#include "../domain-decls.h"
#include "../osstream.h"
#include "CtReference.h"
#include "CtTitaniumArray.h"


CtTitaniumArray::CtTitaniumArray( const CtReference &data,
				  unsigned arity )
  : CtArray( mangle( data, arity ), data.referent ),
    domain( RectDomainNDecl[ arity - 1 ]->cType() ),
    data( data ),
    arity( arity )
{
}


void CtTitaniumArray::elaborateTo( CfLayout &out ) const
{
  domain.define( out );
  data.define( out );

  WithDef arrayDef( out, "ti_ARRAY", name );
  WithDef domainDef( out, "ti_RECTDOMAIN", domain.name );
  WithDef dataDef( out, "PTR_TO_T", data.name );
  WithDef arityDef( out, "N", int2str( arity ) );

  out << "#include <ti_array_layout.h>\n";

  declare( out );
}


const string CtTitaniumArray::mangle( const CtReference &data,
				      unsigned arity )
{
  ostringstream assemble;
  assemble << MANGLE_TYPE_MARKER << MANGLE_TI_ARRAY_TYPE_MARKER
	   << data.titaniumArrayPrefix()
	   << arity
	   << data.referent;

  return assemble.str();
}


// Local Variables:
// c-file-style: "gnu"
// End:
