#include "AST.h"
#include "CodeContext.h"
#include "lgMacro.h"


const string IncrDecrNode::emitBumpExpr( CodeContext &context,
					 bool prefix, bool increment )
{
  const string result = declareTemporary( context );
  
  if (child(0)->isSimpleLvalue()) {
    const char *op = increment ? "++" : "--";
    const string value = prefix
      ? emitPrefixOp(  context, op )
      : emitPostfixOp( context, op );
    context << result << " = " << value << ';' << endCline;
    
  } else {
    const string lval = child(0)->getLvalue( context );
    context << (prefix ? "PRE" : "POST")
	    << '_'
	    << (increment ? "INCR" : "DECR")
	    << lgMacro( "", child(0)->isLocalLvalue() )
	    << '(' << result << ", " << lval << ");"
	    << endCline;
  }
  
  return result;
}


const string PostIncrNode::emitExpression2( CodeContext &context )
{
  return emitBumpExpr( context, false, true );
}


const string PostDecrNode::emitExpression2( CodeContext &context )
{
  return emitBumpExpr( context, false, false );
}


const string PreIncrNode::emitExpression2( CodeContext &context )
{
  return emitBumpExpr( context, true, true );
}


const string PreDecrNode::emitExpression2( CodeContext &context )
{
  return emitBumpExpr( context, true, false );
}
