/* $Id: errors.h 1.6 Wed, 30 Sep 1998 17:13:20 -0700 liblit $  -*-C++-*- */

/* errors.h: Functions for reporting errors */

#ifndef _ERRORS_H_
#define _ERRORS_H_

#include "parse.h"

/* Report message at source position N, giving MSG as the text. */
void Message(const string& msg, const SourcePosn N = NoSourcePosition);

/* Report error at source position N, giving MSG as the text of the */
/* error message. */
void Error(const string& msg, const SourcePosn N = NoSourcePosition);

/* Report warning at source position N, giving MSG as the text of the */
/* error message. */
void Warning(const string& msg, const SourcePosn N = NoSourcePosition);

/* The number of times Error has been called. */
extern int NumErrors();

#endif
