#ifndef _INCLUDE_TITANIUM_IL_CONTEXT_H_
#define _INCLUDE_TITANIUM_IL_CONTEXT_H_

#include <set>

class MethodTypeNode;
class MethodCallNode;

typedef set< MethodCallNode *, less< MethodCallNode * > > StaleSet;


struct LocalContext
{
  LocalContext( StaleSet & );
  LocalContext( const LocalContext &, MethodTypeNode & );

  MethodTypeNode * const method;
  StaleSet &stale;
};
  

inline LocalContext::LocalContext( const LocalContext &parent, MethodTypeNode &method )
  : method( &method ),
    stale( parent.stale )
{
}
  

inline LocalContext::LocalContext( StaleSet &stale )
  : method( 0 ),
    stale( stale )
{
}


#endif // !_INCLUDE_TITANIUM_IL_CONTEXT_H_
