#include "AST.h"
#include "enact-context.h"


void ExprNode::localEnact( const LocalEnactContext & )
{
  if (type()->localInferable())
    type( 0 );
}


////////////////////////////////////////////////////////////////////////


void CastNode::localEnact( const LocalEnactContext &context )
{
  ExprNode::localEnact( context );

  if (dtype()->localEnactType( context ))
    localReportChange( "cast", *dtype() );
}


void InstanceOfNode::localEnact( const LocalEnactContext &context )
{
  if (dtype()->localEnactType( context ))
    localReportChange( "instanceof", *dtype() );
}


void ThisNode::localEnact( const LocalEnactContext &context )
{
  ExprNode::localEnact( context );
  
  if (isLocal() && !*context.thisLocal)
    error( "local inference removed implicit locality qualification" );
  isLocal( *context.thisLocal );
}
