#include "AST.h"
#include "solver.h"
#include "var.h"


LocalSolver *LocalSolver::active = 0;


LocalSolver::LocalSolver()
{
  active = this;
}


LocalSolver::~LocalSolver()
{
  active = 0;
}


LocalSolver &LocalSolver::singleton()
{
  return *active;
}


void LocalSolver::conservative( const TypeNode &type )
{
  if (!type.isLocal())
    mustBeGlobal( type );
}


void LocalSolver::identicalTo( const TreeNode &node1,
			       const TreeNode &node2 )
{
  assert( &node1 != &node2 );
  LocalBaneSolver::identicalTo( LocalVar( node1 ), LocalVar( node2 ) );
}


void LocalSolver::mustBeGlobal( const TypeNode &type )
{
  assert( !type.isLocal() );
  LocalBaneSolver::mustBeGlobal( LocalVar( type ) );
}


void LocalSolver::subsumedBy( const TypeNode &lesser,
			      const TypeNode &greater )
{
  assert( &lesser != &greater );
  LocalBaneSolver::subsumedBy( LocalVar( lesser ), LocalVar( greater ) );
}
