#include <stdio.h>
#include <stdlib.h>
#include "ti-gc.h"
#include "main.h"
#include "procs.h"
#include "spawn.h"

int PROCS;
char *RUNTIME_MODEL = "pthread";

int main(int argc, char **argv)
{
  const char * envar;

  /* do this *very* early, in case library routines allocate memory */
  ti_mem_thr_init(&argv);
  region_init();

  envar = getenv( "TI_NODES" );
  if (envar)
    {
      char *end;
      PROCS = strtol( envar, &end, 0 );

      if (*end || PROCS <= 0)
	{
	  fprintf (stderr,
		   "%s: (Error) Environment variable TI_NODES must be a number greater than zero: \"%s\".\n",
		   argv[0] ? argv[0] : "<Unknown>",
		   envar ? envar : "<Unknown>");
	  return -1;
	}
    }
  else
    PROCS = 1;

  barrier_init();
  spawn( argc, argv );
  return 0;
}
