#ifndef _include_assign_h_
#define _include_assign_h_

#include <gp-trace/gp-trace.h>
#include "libsplit-c.h"


#define _ASSIGN_GLOBAL(ptr, val, send)			\
  do {							\
    gp_trace_event( "assign", isLocal(ptr) );		\
							\
    if (isLocal(ptr))					\
      *(ptr).addr = val;				\
    else {						\
      const ___globPtrType sc = scPtr(ptr);		\
							\
      switch (sizeof(*(ptr).addr)) {			\
      case 1:						\
	__c_ ## send (sc, *(char *)&val);		\
	break;						\
      case 2:						\
	__sh_ ## send (sc, *(short *)&val);		\
	break;						\
      case 4:						\
	__i_ ## send (sc, *(int *)&val);		\
	break;						\
      case 8:						\
	__ll_ ## send (sc, *(long long *)&val);		\
	break;						\
      default:						\
	bulk_ ## send (sc, &val, sizeof(*(ptr).addr));	\
      }							\
    }							\
  } while (0)

#define ASSIGN_GLOBAL(     ptr, val)  _ASSIGN_GLOBAL(ptr, val, write)
#define WEAK_ASSIGN_GLOBAL(ptr, val)  _ASSIGN_GLOBAL(ptr, val, put)


#endif /* !_include_assign_h_ */
