#ifndef _include_bulk_h_
#define _include_bulk_h_

#include <string.h>


#define local_to_global_copy( local, global, count )				\
  do {										\
    if (isLocal( global ))							\
      memcpy(   TO_LOCAL( global ), (local), sizeof(*(local)) * (count) );	\
    else									\
      bulk_write( scPtr( global ), (local), sizeof(*(local)) * (count) );	\
  } while (0)


#define global_to_local_copy( global, local, count )				\
  do {										\
    if (isLocal( global ))							\
      memcpy(   (local), TO_LOCAL( global ), sizeof(*(local)) * (count) );	\
    else									\
      bulk_read( (local),  scPtr( global ), sizeof(*(local)) * (count) );	\
  } while (0)



#endif /* !_include_bulk_h_ */
