#ifndef _INCLUDE_JAVA_ARRAY_METHODS_H_
#define _INCLUDE_JAVA_ARRAY_METHODS_H_

#include "java_array.h"
#include "linkage.h"
#include "native-utils.h"
#include "regions.h"

EXTERN_C_BEGIN


/* external helper functions */
void m16checkArrayBoundsIIImT11NativeUtils4lang2ti( jint, jint, jint );

/* internal helper functions */
java_array_header *java_array_alloc( Region, int length, int elementSize );
java_array_header *java_array_build(         int length, int elementSize, void *data );


#define JAVA_ARRAY_INIT_( result, init )  *((java_array_header **) &(result)) = (init)

#define JAVA_ARRAY_ALLOC( result, region, length, ElementType )  JAVA_ARRAY_INIT_( result, java_array_alloc( (region), (length), sizeof( ElementType ) ) )
#define JAVA_ARRAY_BUILD( result, length, data )                 JAVA_ARRAY_INIT_( result, java_array_build( (length), sizeof(*data), data ) )


#define JAVA_ARRAY_FIELD_( form, result, array, fieldName, fieldType )	\
  do {									\
    fieldType fieldAddr_;						\
    									\
    CHECK_NULL_ ## form ( array );					\
    									\
    FIELD_ADDR_ ## form ( fieldAddr_, array, header.fieldName );	\
    DEREF_ ## form ( result, fieldAddr_ );				\
  } while (0)

#define JAVA_ARRAY_LENGTH_GLOBAL( result, array )  JAVA_ARRAY_FIELD_( GLOBAL, result, array, length, Pjint )
#define JAVA_ARRAY_LENGTH_LOCAL(  result, array )  JAVA_ARRAY_FIELD_( LOCAL,  result, array, length, Ljint )
#define JAVA_ARRAY_SIZE_GLOBAL(   result, array )  JAVA_ARRAY_FIELD_( GLOBAL, result, array, size,   Pjint )
#define JAVA_ARRAY_SIZE_LOCAL(    result, array )  JAVA_ARRAY_FIELD_( LOCAL,  result, array, size,   Ljint )

#ifndef BOUNDS_CHECKING
#define BOUNDS_CHECKING 1
#endif

#if BOUNDS_CHECKING
#define JAVA_ARRAY_CHECK_( form, array, offset, count )				\
  do {										\
    jint safe_;									\
    JAVA_ARRAY_LENGTH_ ## form ( safe_, (array) );				\
    m16checkArrayBoundsIIImT11NativeUtils4lang2ti( safe_, (offset), (count) );	\
  } while (0)
#else
#define JAVA_ARRAY_CHECK_( form, array, offset, count ) do {} while(0)
#endif /* BOUNDS_CHECKING */

#define JAVA_ARRAY_CHECK_GLOBAL( array, offset, count )  JAVA_ARRAY_CHECK_( GLOBAL, array, offset, count )
#define JAVA_ARRAY_CHECK_LOCAL(  array, offset, count )  JAVA_ARRAY_CHECK_( LOCAL,  array, offset, count )

EXTERN_C_END

#endif /* !_INCLUDE_JAVA_ARRAY_METHODS_H_ */
