#include <stdlib.h>
#include <string.h>

#include <class_header.h>
#include <native-stubs.h>
#include <ti-memory.h>
#include "T9Cloneable4lang4java.h"

#ifdef HAVE_MONITORS
#include "layout!PLtitanium_monitor_t.h"
#endif


typedef PT6Object4lang4java GP_Object;
typedef LT6Object4lang4java LP_Object;

jboolean m7isLocalmT6Object4lang4java(PT6Object4lang4java me) {
  return isLocal(me);
}

jint m7creatormT6Object4lang4java(PT6Object4lang4java me) {
  CHECK_NULL_GLOBAL(me);
  return TO_PROC(me);
}

jint m8hashCodemT6Object4lang4java (PT6Object4lang4java p) {
  return TO_PROC(p) ^ ((int) TO_LOCAL(p));
}

void m17object_initializemT6Object4lang4java(LT6Object4lang4java p) {
  p->monitor = monitor_init();
}

void m15object_finalizemT6Object4lang4java(PT6Object4lang4java p) {
#ifdef HAVE_MONITORS
  PLtitanium_monitor_t fieldAddr;
  Ltitanium_monitor_t monitor;
  
  FIELD_ADDR_GLOBAL(fieldAddr, p, monitor);
  DEREF_GLOBAL(monitor, fieldAddr);
  monitor_destroy(monitor);
#endif /* monitors */
}

void m6notifymT6Object4lang4java(PT6Object4lang4java p) {
#ifdef HAVE_MONITORS
  PLtitanium_monitor_t fieldAddr;
  Ltitanium_monitor_t monitor;
  
  FIELD_ADDR_GLOBAL(fieldAddr, p, monitor);
  DEREF_GLOBAL(monitor, fieldAddr);
  monitorNotify(monitor, TO_PROC(p));
#else /* no monitors */
  fputs( "unimplemented native method: m6notifymT6Object4lang4java\n", stderr );
  exit(2);
#endif /* no monitors */
}

void m9notifyAllmT6Object4lang4java(PT6Object4lang4java p) {
#ifdef HAVE_MONITORS
  PLtitanium_monitor_t fieldAddr;
  Ltitanium_monitor_t monitor;
  
  FIELD_ADDR_GLOBAL(fieldAddr, p, monitor);
  DEREF_GLOBAL(monitor, fieldAddr);
  monitorNotifyAll(monitor, TO_PROC(p));
#else /* no monitors */
  fputs( "unimplemented native method: m9notifyAllmT6Object4lang4java\n", stderr );
  exit(2);
#endif /* no monitors */
}

void m4waitJmT6Object4lang4java(PT6Object4lang4java p, jlong millis) {
#ifdef HAVE_MONITORS
  PLtitanium_monitor_t fieldAddr;
  Ltitanium_monitor_t monitor;
  
  FIELD_ADDR_GLOBAL(fieldAddr, p, monitor);
  DEREF_GLOBAL(monitor, fieldAddr);
  monitorWait(monitor, millis, TO_PROC(p));
#else /* no monitors */
  fputs( "unimplemented native method: m4waitJmT6Object4lang4java\n", stderr );
  exit(2);
#endif /* no monitors */
}


Region m8regionOfmT6Object4lang4java(GP_Object me) {
  return PG2Region(me);
}


static size_t allocateClone( const ti5cdescmT6Object4lang4java *info, LP_Object *duplicate )
{
  if (CLASS_IMPLEMENTS( info, fi5cdescT9Cloneable4lang4java ))
    {
      *duplicate = (LP_Object) ti_malloc( info->size );
      return info->size;
    }
  else
    {
      m31throwCloneNotSupportedExceptionmT11NativeUtils4lang2ti();
      return 0;
    }
}


LP_Object m10localClonemT6Object4lang4java( LP_Object me )
{
  const ti5cdescmT6Object4lang4java * const info = me->class_info;
  LP_Object duplicate;
  const size_t size = allocateClone( info, &duplicate );
  
  memcpy( duplicate, me, size );
  return duplicate;
}


#ifdef ALLOW_CLONE_EVEN_THOUGH_ITS_SEMANTICS_MAY_CHANGE
LP_Object m5clonemT6Object4lang4java( GP_Object me )
{
  ti5cdescmT6Object4lang4java *info;
  CLASS_INFO_GLOBAL( info, ti5cdescmT6Object4lang4java, me );
  
  {
    LP_Object duplicate;
    const size_t size = allocateClone( info, &duplicate );
    char * const bytes = (char *) duplicate;
  
    global_to_local_copy( me, bytes, size );
    info->nullifyLocalFields( duplicate );
    return duplicate;
  }
}
#else
unimplemented(m5clonemT6Object4lang4java, LP_Object, (GP_Object me))
#endif

     
unimplemented(m8getClassmT6Object4lang4java, PT5Class4lang4java, (GP_Object me))
