tlib_dir    = $(top_srcdir)/tlib
tlib_java   = $(tlib_dir)/tlib.java
tlib_base   = libtlib-$(backend)
tlib_g	    = $(tlib_base)-g.a
tlib_O      = $(tlib_base)-O.a
tlibs	    = $(tlib_g) $(tlib_O)
tlib_incdir = $(datadir)/tlib-include
tlib_kind   = $(patsubst $(tlib_base)%.a,%,$@)

tc            = $(top_builddir)/tc
tcbuild_exec  = tcbuild
tcbuild	      = $(top_builddir)/tcbuild/$(tcbuild_exec)
tc_cache      = tc-cache$(tlib_kind)
tc_gen        = tc-gen$(tlib_kind)
tcbuild_flags = --backend $(backend) --cache-dir $(tc_cache) --generate-dir $(tc_gen) --keep --library --outfile $@ --rebuild-tlib $(tlib_kind)



force:

#$(tc): force
#	$(MAKE) -C $(@D) $(@F) all-am

$(tcbuild): force
	$(MAKE) -C $(@D)

tlib: tlib_g tlib_O
tlib-g tlib_g: $(tlib_g)
tlib-O tlib_O: $(tlib_O)

#$(tlibs): $(tlib_java) $(tc) $(tcbuild)
$(tlibs): $(tlib_java) $(tcbuild)
	$(tcbuild) $(tcbuild_flags) $<
	[ -r $@ ] && touch $@

install-tlib: $(tlibs)
	$(mkinstalldirs) $(libdir)
	$(INSTALL_DATA) $(tlib_g) $(libdir)/$(tlib_g)
	$(INSTALL_DATA) $(tlib_O) $(libdir)/$(tlib_O)

uninstall-tlib:
	rm -f $(libdir)/$(tlib_g) $(libdir)/$(tlib_O)

install-tlib-headers: $(tlibs)
	$(mkinstalldirs) $(tlib_incdir)
	@cd tc-gen-O;								\
	set -x;									\
	for header in *.h; do							\
	  $(INSTALL_DATA) "$$header" "$(tlib_incdir)/$$header" || exit 1 ;	\
	done

uninstall-tlib-headers:
	rm -f $(tlib_incdir)/*.h


CLEANFILES = $(tlibs)

clean-tc-dirs:
	rm -rf tc-cache-O tc-cache-g tc-gen-O tc-gen-g
