(defun initialize-buffer (nodes builder)
  (insert-c++-comment-prefix nodes builder)
  (insert "#include <iostream>\n"
	  "\n"
	  "#include \"AST.h\"\n"
	  "\n"
	  "\n"))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


(defun defnode* (name parents fields methods states)
  (let* ((details (resolve-fields fields))
	 (kids (aref details 0)))
    (insert
     (format "%s *%s::clone () const { %s* copy = new %s(*this); copy->children = %s; return copy; }\n"
	     name name name name (if kids "copy->_children" "NULL")))))


(defun deflistnode* (name methods)
  (insert
   (format "\n\n\t/* Class %s */\n" name)
   (format "%s *%s::clone () const\n{\n" name name)
   (format "  %s* copy = new %s; *copy = *this;\n" name name)
   "  copy->children = new TreeNode*[_arity];\n"
   "  memcpy(copy->children, children, _arity * sizeof(*children));\n"
   "  return copy;\n}\n\n"))
